/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is spamdump extension.
 *
 * The Initial Developer of the Original Code is
 * Noriyuki J. INOUE.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
/*
	reference:
	
	http://lxr.mozilla.org/mozilla/source/mailnews/extensions/bayesian-spam-filter/src/nsBayesianFilter.cpp#1227
    Format of the training file for version 1:
    [0xFEEDFACE]
    [number good messages][number bad messages]
    [number good tokens]
    [count][length of word]word
    ...
    [number bad tokens]
    [count][length of word]word
    ...
*/

/*
	reference:
	
	http://lxr.mozilla.org/mozilla/source/mailnews/extensions/bayesian-spam-filter/src/nsBayesianFilter.cpp#1213
	static nsresult getTrainingFile(nsCOMPtr<nsILocalFile>& file)
	{
	    // should we cache the profile manager's directory?
	    nsCOMPtr<nsIFile> profileDir;

	    nsresult rv = NS_GetSpecialDirectory(NS_APP_USER_PROFILE_50_DIR, getter_AddRefs(profileDir));
	    NS_ENSURE_SUCCESS(rv, rv);
	    rv = profileDir->Append(NS_LITERAL_STRING("training.dat"));
	    if (NS_FAILED(rv)) return rv;
	    
	    file = do_QueryInterface(profileDir, &rv);
	    return rv;
	}
*/

/*
	reference:
	
	http://lxr.mozilla.org/mozilla/source/xpcom/io/nsAppDirectoryServiceDefs.h#98
	#define NS_APP_USER_PROFILE_50_DIR              "ProfD"
*/

/*
	reference:
	
	http://piro.sakura.ne.jp/xul/tips/x0010.html
	const DIR = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
	var fileOrDir = DIR.get('', Components.interfaces.nsIFile);
	
	// 'file:///c:/windows/...' ̌`
	try {
	    const ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
	    var URL =ioService.getURLSpecFromFile(tempLocalFile);
	} catch(e) { // NS6 ł͂̕@
	    var URL  = fileOrDir.URL;
	}

	// 'C:\windows\...' ̌`
	var path = fileOrDir.QueryInterface(Components.interfaces.nsILocalFile).path;
*/
/*
	reference:
	
	http://level.s69.xrea.com/mozilla/spam/spamdump
*/

/*
	reference:
	
	http://lxr.mozilla.org/mozilla/source/mailnews/extensions/bayesian-spam-filter/src/nsBayesianFilter.cpp#970
    // if hamcount and spam count are both 0, we could end up with a divide by 0 error, 
    // tread carefully here. (Bug #240819)
    double probDenom = (hamcount *nBadMail + spamcount*nGoodMail);
    if (probDenom == 0.0) // nGoodMail and nBadMail are known to be non zero or we wouldn't be here
    	probDenom = nBadMail + nGoodMail; // error case use a value of 1 for hamcount and spamcount if they are both zero.
	
    prob = (spamcount * nGoodMail)/probDenom;
    double n = hamcount + spamcount;
    prob =  (0.225 + n * prob) / (.45 + n);
*/

/*
	reference:
	
	http://www.xulplanet.com/tutorials/xultu/treeview.html
*/

/*
	reference:
	
	http://lxr.mozilla.org/mozilla/source/nsprpub/pr/include/prio.h#612
	#define PR_RDONLY       0x01
	#define PR_WRONLY       0x02
	#define PR_RDWR         0x04
	#define PR_CREATE_FILE  0x08
	#define PR_APPEND       0x10
	#define PR_TRUNCATE     0x20
	#define PR_SYNC         0x40
	#define PR_EXCL         0x80
*/

function loadButton_click()
{
	var filePath = Components.classes['@mozilla.org/file/directory_service;1'].
		getService(Components.interfaces.nsIProperties).
		get('ProfD', Components.interfaces.nsIFile);
	
	filePath.append(document.getElementById('filenameBox').value);
	
	var filePathLocal = filePath.QueryInterface(Components.interfaces.nsILocalFile);
	
	var outputBox = document.getElementById('outputBox');
	outputBox.value = "path:" + filePathLocal.path + "\n";
	
	var fstream = Components.classes['@mozilla.org/network/file-input-stream;1'].
		createInstance(Components.interfaces.nsIFileInputStream);
	fstream.init(filePathLocal, 0x01, 0, false);
	
	var bstream = Components.classes['@mozilla.org/binaryinputstream;1'].
		createInstance(Components.interfaces.nsIBinaryInputStream);
	
	bstream.setInputStream(fstream.QueryInterface(Components.interfaces.nsIInputStream));
	
	var num = bstream.read32();
	var v2 = false;
	if(num == 0xFACE0000){
		outputBox.value += "This data is private version.\n";
		v2 = true;
	}
	else if(num != 0xFEEDFACE){
		outputBox.value += "Invalid header.\n";
	}
	
	nGoodMail = bstream.read32();
	outputBox.value += "Number of good messages: " + nGoodMail + "\n";
	
	nBadMail = bstream.read32();
	outputBox.value += "Number of bad messages: " + nBadMail + "\n";
	
	// http://lxr.mozilla.org/seamonkey/source/calendar/resources/content/importExport.js#87
	var unicodeConverter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
		createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	unicodeConverter.charset = "UTF-8";
	
	var i;
	var wordFolder = new Object();
	
	nGoodToken = bstream.read32();
	outputBox.value += "Number of good tokens: " + nGoodToken + "\n";
	
	for(i=0; i<nGoodToken; i++){
		var count = bstream.read32();
		var len = bstream.read32();
		var s = bstream.readBytes(len);
		s = unicodeConverter.ConvertToUnicode( s );
		wordFolder[s] = new token(s);
		wordFolder[s].goodCount = count;
	}
	
	nBadToken = bstream.read32();
	outputBox.value += "Number of bad tokens: " + nBadToken + "\n";
	
	for(i=0; i<nBadToken; i++){
		var count = bstream.read32();
		var len = bstream.read32();
		var s = bstream.readBytes(len);
		s = unicodeConverter.ConvertToUnicode( s );
		if(wordFolder[s] == null){
			wordFolder[s] = new token(s);
		}
		wordFolder[s].badCount = count;
	}
	
	if(v2){
		num = bstream.read32();
		outputBox.value += "Number of good messages: " + num + "\n";
		
		num = bstream.read32();
		outputBox.value += "Number of bad messages: " + num + "\n";
		
		num = bstream.read32();
		outputBox.value += "Number of good tokens: " + num + "\n";
		
		for(i=0; i<num; i++){
			var count = bstream.read32();
			var len = bstream.read32();
			var s = bstream.readBytes(len);
			s = unicodeConverter.ConvertToUnicode( s );
			s = "V2:" + s;
			if(wordFolder[s] == null){
				wordFolder[s] = new token(s);
			}
			wordFolder[s].goodCount = count;
		}
		
		num = bstream.read32();
		outputBox.value += "Number of bad tokens: " + num + "\n";
		
		for(i=0; i<num; i++){
			var count = bstream.read32();
			var len = bstream.read32();
			var s = bstream.readBytes(len);
			s = unicodeConverter.ConvertToUnicode( s );
			s = "V2:" + s;
			if(wordFolder[s] == null){
				wordFolder[s] = new token(s);
			}
			wordFolder[s].badCount = count;
		}
	}
	
	bstream.close();
	fstream.close();
	
	outputBox.value += "Creating master table...\n";
	i=0; for(var prop in wordFolder) i++;
	words = new Array(i);
	i=0; for(var prop in wordFolder){
		words[i] = wordFolder[prop];
		words[i].ref = i;
		i++;
	}
	calculateProbability();
	
	outputBox.value += "Updating view...\n";
	updateFilter();
	
	outputBox.value += "done.\n";
}

function calculateProbability()
{
	for(var i=0; i<words.length; i++){
		var probDenom = words[i].goodCount*nBadToken + words[i].badCount*nGoodToken;
		if(probDenom == 0) probDenom = nGoodToken + nBadToken;
		var prob = (words[i].badCount*nGoodToken)/probDenom;
		var n = words[i].goodCount + words[i].badCount;
		words[i].probability = Math.floor(((0.225 + n*prob)/(0.45+n))*10000)/10000;
	}
}

function saveButton_click()
{
	var filePath = Components.classes['@mozilla.org/file/directory_service;1'].
		getService(Components.interfaces.nsIProperties).
		get('ProfD', Components.interfaces.nsIFile);
	
	filePath.append(document.getElementById('filenameBox').value);
	
	var filePathLocal = filePath.QueryInterface(Components.interfaces.nsILocalFile);
	
	var outputBox = document.getElementById('outputBox');
	outputBox.value += "path:" + filePathLocal.path + "\n";
	
	var fstream = Components.classes['@mozilla.org/network/file-output-stream;1'].
		createInstance(Components.interfaces.nsIFileOutputStream);
	fstream.init(filePathLocal, 0x02+0x08, 0, false);
	
	var bstream = Components.classes['@mozilla.org/binaryoutputstream;1'].
		createInstance(Components.interfaces.nsIBinaryOutputStream);
	
	bstream.setOutputStream(fstream.QueryInterface(Components.interfaces.nsIOutputStream));
	
	bstream.write32(0xFEEDFACE);
	
	outputBox.value += "number of good message: " + nGoodMail + "\n";
	outputBox.value += "number of bad message: " + nBadMail + "\n";
	bstream.write32(nGoodMail);
	bstream.write32(nBadMail);
	
	var i;
	var goodWords = new Array(words.length);
	var badWords = new Array(words.length);
	var nGood = 0;
	var nBad = 0;
	for(i=0; i<words.length; i++){
		if(words[i].word == "") continue;
		if(words[i].goodCount != 0) goodWords[nGood++] = words[i];
		if(words[i].badCount != 0) badWords[nBad++] = words[i];
	}
	outputBox.value += "number of good token: " + nGood + "\n";
	outputBox.value += "number of bad token: " + nBad + "\n";
	
	var unicodeConverter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
		createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	unicodeConverter.charset = "UTF-8";
	
	var progressBox = document.getElementById('progressBox');
	
	outputBox.value += "writing good token... " + nGood + "\n";
	bstream.write32(nGood);
	for(i=0; i<nGood; i++){
		bstream.write32(goodWords[i].goodCount);
		var s = unicodeConverter.ConvertFromUnicode( goodWords[i].word );
		bstream.write32(s.length);
		bstream.writeBytes(s, s.length);
	}
	
	outputBox.value += "writing bad token... " + nBad + "\n";
	bstream.write32(nBad);
	for(i=0; i<nBad; i++){
		bstream.write32(badWords[i].badCount);
		var s = unicodeConverter.ConvertFromUnicode( badWords[i].word );
		bstream.write32(s.length);
		bstream.writeBytes(s, s.length);
	}
	
	bstream.close();
	fstream.close();
	
	outputBox.value += "done.\n";
}

function token(word)
{
	this.word = word;
	this.goodCount = 0;
	this.badCount = 0;
	this.probability = 0;
	this.ref = 0;
}

function compareWord(t1, t2)
{
	return sortOrder*( t1.word > t2.word ? -1 : 1 );
}

function compareGoodCount(t1, t2)
{
	return sortOrder*(t1.goodCount > t2.goodCount ? -1 : 1 );
}

function compareBadCount(t1, t2)
{
	return sortOrder*(t1.badCount > t2.badCount ? -1 : 1 );
}

function compareTotalCount(t1, t2)
{
	return sortOrder*(t1.goodCount + t1.badCount > t2.goodCount + t2.badCount ? -1 : 1 );
}

function compareProbability(t1, t2)
{
	return sortOrder*(t1.probability > t2.probability ? -1 : 1 );
}

var words;				// master array of all words and data
var filteredWords;		// array of filtered words
var nGoodMail;			// number of ham mail
var nBadMail;			// number of spam mail
var nGoodToken;			// number of ham token
var nBadToken;			// number of spam token
var sortOrder = 1;		// sort order: 1 or -1
var sortingColumn = "";	// current sorting column
var tid = 0;			// ID of delayed executing timer

var treeView = {
    rowCount : 0,
    getCellText : function(row,column){
    	switch(column){
    		case "wordColumn":  return filteredWords[row].word;
    		case "goodColumn":  return filteredWords[row].goodCount;
    		case "badColumn":   return filteredWords[row].badCount;
    		case "totalColumn": return filteredWords[row].goodCount + filteredWords[row].badCount;
    		case "probColumn":  return filteredWords[row].probability;
    	}
    },
    setTree: function(treebox){ this.treebox=treebox; },
    isContainer: function(row){ return false; },
    isSeparator: function(row){ return false; },
    isSorted: function(row){ return false; },
    getLevel: function(row){ return 0; },
    getImageSrc: function(row,col){ return null; },
    getRowProperties: function(row,props){},
    getCellProperties: function(row,col,props){},
    getColumnProperties: function(colid,col,props){},
    cycleHeader: function(column){
    	if(sortingColumn == column){
    		sortOrder = -sortOrder;
    	}else{
    		sortOrder = 1;
    	}
    	sortColumn(column);
    	sortingColumn = column;
		this.treebox.invalidate();
	}
};

function sortColumn(column)
{
	switch(column){
		case "wordColumn":  filteredWords.sort(compareWord); break;
		case "goodColumn":  filteredWords.sort(compareGoodCount); break;
		case "badColumn":   filteredWords.sort(compareBadCount); break;
		case "totalColumn": filteredWords.sort(compareTotalCount); break;
		case "probColumn":  filteredWords.sort(compareProbability); break;
	}
}

function setView()
{
    document.getElementById('outputTree').view=treeView;
}

function filterBox_keyup()
{
	// http://lxr.mozilla.org/mozilla/source/mailnews/base/resources/content/searchBar.js#475
	// delay executing function
	window.clearTimeout(tid);
	tid = window.setTimeout("updateFilter();", 800);
}

function deleteButton_click()
{
	// http://www.xulplanet.com/tutorials/xultu/seltree.html
	var tree = document.getElementById('outputTree');
	var start = new Object();
	var end = new Object();
	var numRanges = tree.view.selection.getRangeCount();

	for (var t=0; t<numRanges; t++){
		tree.view.selection.getRangeAt(t,start,end);
		for (var v=start.value; v<=end.value; v++){
	    	filteredWords[v].word = "";
	    	if(filteredWords[v].goodCount) nGoodToken--;
	    	if(filteredWords[v].badCount) nBadToken--;
		}
	}
	tree.view.selection.currentIndex = 0;
	tree.view.selection.clearSelection();
	calculateProbability();
	updateFilter();
}

function copyButton_click()
{
	// http://www.xulplanet.com/tutorials/xultu/clipboard.html
	
	var tree = document.getElementById('outputTree');
	var start = new Object();
	var end = new Object();
	var numRanges = tree.view.selection.getRangeCount();
	var str = "Token\tGood\tBad\tProb.\n";
	
	for (var t=0; t<numRanges; t++){
		tree.view.selection.getRangeAt(t,start,end);
		for (var v=start.value; v<=end.value; v++){
	    	str += filteredWords[v].word + "\t" +
	    		filteredWords[v].goodCount + "\t" +
	    		filteredWords[v].badCount + "\t" +
	    		filteredWords[v].probability + "\n";
		}
	}
	
	const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
		.getService(Components.interfaces.nsIClipboardHelper);
	gClipboardHelper.copyString(str);
	
	var copyButton = document.getElementById('copyButton');
	window.setTimeout("document.getElementById('copyButton').label='Copy selection'" , 1000);
	copyButton.label = "Copy: " + tree.view.selection.count;
}


function updateFilter()
{
	var n = 0;
	var filter = document.getElementById('filterBox').value;
	
	var opts = filter.split(" ");
	filter = opts.length ? opts[opts.length-1] : "";
	
	if(filter == ""){
		filteredWords = new Array(words.length);
		for(var i=0; i<words.length; i++){
			if(words[i].word != ""){
				filteredWords[n] = words[i];
				n++;
			}
		}
		filteredWords = filteredWords.slice(0, n);
	}else{
		var regexp = false;
		var not = false;
		
		for(var i=0; i<opts.length-1; i++){
			switch(opts[i].toLowerCase()){
				case "regexp": regexp = true; break;
				case "not": not = true; break;
			}
		}
		
		filteredWords = new Array(words.length);
		if(regexp){
			re = new RegExp(filter);
			for(var i=0; i<words.length; i++){
				if(not^(re.exec(words[i].word)!=null)){
					filteredWords[n] = words[i];
					n++;
				}
			}
		}else{
			for(var i=0; i<words.length; i++){
				if(not^(words[i].word.indexOf(filter)!=-1)){
					filteredWords[n] = words[i];
					n++;
				}
			}
		}
		filteredWords = filteredWords.slice(0, n);
	}
	sortColumn(sortingColumn);
	document.getElementById('matchBox').value = n;
	treeView.rowCount = n;
	setView();
}

